<?php
	class MdlUser extends Mdl {
		function test($name, $pass, &$cookie) {
			$sth = $this->pdo()->prepare('SELECT pass, cookie FROM user WHERE name = :name');
			$sth->execute(array('name' => $name));
			if ($select = $sth->fetch() and password_verify($pass, $select['pass'])) {
				$cookie = $select['cookie'];
				return true;
			}
			return false;
		}
		function testCookie($cookie, &$user) {
			$sth = $this->pdo()->prepare('SELECT id, name, fullname, cookie FROM user WHERE cookie = :cookie');
			$sth->execute(array('cookie' => $cookie));
			$user = $sth->fetch();
			return $sth->rowCount() === 1;
		}
		
		function getAllUsers() {
			$sth = $this->pdo()->prepare('SELECT id, name, fullname FROM user');
			$sth->execute();
			return $sth->fetchAll();
		}
		
		function updateUser($name, $pass, $fullname = '') {
			$pass = password_hash($pass, PASSWORD_DEFAULT);
			$sth = $this->pdo()->prepare('INSERT INTO user (name, pass, fullname, cookie) VALUES (:name, :pass, :fullname, :cookie) ON DUPLICATE KEY UPDATE pass = :pass, fullname = :fullname, cookie = :cookie');
			return $sth->execute(array('name' => $name, 'pass' => $pass, 'fullname' => $fullname, 'cookie' => bin2hex(random_bytes(13))));
		}
		
		function deleteUser($name) {
			return $this->pdo()->prepare('DELETE FROM user WHERE name = :name')->execute(array('name' => $name));
		}
		
		function setCookie($id, $cookie) {
			$sth = $this->pdo()->prepare('UPDATE user SET cookie = :cookie WHERE id = :id');
			return $sth->execute(array('id' => $id, 'cookie' => $cookie));
		}
	}
?>
