<?php
	class AUTH {
		static function GetUser($key = null) {
			static $user = null;
			if (!$user)
				(new MdlUser())->testCookie(@$_COOKIE['fc'], $user);
			return $key ? @$user[$key] : $user;
		}
		
		static function IsLoggedIn() {
			return !!static::GetUser();
		}
		static function LogIn($user, $pass) {
			if ((new MdlUser())->test($user, $pass, $cookie)) {
				setcookie('fc', $cookie, 0, '/');
				$_COOKIE['fc'] = $cookie;
				return true;
			}
			return false;
		}
		static function LogOut() {
			setcookie('fc', '', 1, '/');
			return true;
		}
		
		static function IsAdmin() {
			return @static::GetUser('name') === 'admin';
		}
		
		static function ResetCookie() {
			$cookie = bin2hex(random_bytes(13));
			(new MdlUser())->setCookie(static::GetUser()['id'], $cookie);
			setcookie('fc', $cookie, 0, '/');
			return true;
		}
	}
?>
